#!/usr/bin/perl -w

use File::Copy;

# version Linux ...

#######################################################
# function b_synchronise
# b_synchronise direction(string) contexte(string)
#    faire une liste des rpertoires  synchroniser
#       direction='get' (<-master), ='push' (->master)
#       ouvrir les tiroirs un  un
#       prendre les chemins des chemises
#    vrifier le contenu de la disquette? (optionnel)
#    vrifier le contenu du CDROM? (optionnel)
#    chercher la base "master" dans contexte.bib
#       ouvrir une connection; lister et mettre  jour
#######################################################

#################################
# les connections rseau :
#   - connection monte
#   - client FTP
################################
$contexte=$ARGV[1];
$sens=$ARGV[0];
    #$rep='/home/bidon/biblio/';
$rep=$ENV{'HOME'}.'/biblio/'; print("$rep\n"); chdir($rep);
$ncops=0;

# dterminer ou est le master?
open(f,'<biblio.ini') ||die 'biblio.ini not found' ;
# while (<f>) {chop;chop; if ($_ eq "[master]") {last}; }
$afile=<f>; $afile=<f>;$afile=<f>; $mode=<f>;$master=<f>;chomp($master);
close(f);
print("la racine du montage est : $master\nsens : $sens\n");
#$master='192.168.2.1';

#rcuprer la liste des rpertoires (du contexte) dans %chemins;
# Faire la liste des guess (les "top" rpertoires) dans %guess;


@f = <$contexte*.box>;
$n=0;
foreach (@f) {
  $fic=$_;
  open(ff,$fic)|| die "pas de fichier box";
  $afile=<ff>; #ligne de titre
  while (<ff>)
     {chop;chomp;
      if (/^\[/) {last};
      $chemins[$n]=$_; $matches[$n]='0'; chop; $guess[$n]=substr($_,1+rindex($_,'/'));
      print("$chemins[$n] et guess : $guess[$n]\n"); $n++; $afile=<ff>; $afile=<ff>;
     }; #while (<ff>)
  close(ff);
}; #foreach (@f)

#quelle machine master et quel protocole?
# protocoles :
# montage sur /mnt/biblio
# ftp://master/
#
 

#############################################################
# chercher une maj sur un montage local du master (mountpoint)
#############################################################

#ici on regarde dans /mnt/biblio
if (-e "$master\/biblio")
 {  print("$master est mont\n");

#chercher rcursivement les guess dans /mnt/biblio
#mettre dans %matches les chemins distants
require Cwd;
$start_dir = Cwd::cwd();
chdir($master);
find($master);  
chdir($start_dir);  
# dans chaque %chemins copier le contenu de %matches 
# copier chaque fichier qui est plus rcent
# respecter la date du fichier
# foreach (@matches) {print("match $_\n");};
$n=0; foreach (@chemins) 
{print("$matches[$n],$chemins[$n]\n");
if ($matches[$n] ne '0')
  {if ($sens eq 'get'){DirCopyRecent($matches[$n],$chemins[$n])}
                          else{DirCopyRecent($chemins[$n],$matches[$n])};}
$n++;
};

open(logf,'>copying.log');
foreach (@copied) {print logf ("$_ \n")};
close(logf);

#faire un fichier chemin<->matche
open(logf,'>bibliosynch.log');
$n=0; foreach (@chemins) { if ($matches[$n] ne '0') {print logf ("$_=$matches[$n]\n")}; $n++; };
close(logf);
 } 

###########################################
# chercher une maj sur le ftp du master
###########################################
  
#ici on fait du client ftp 
 else 
  {print("$master n est pas mont\n");
  };





#################################
# chercher une maj sur le CDROM
#################################

#le CDROM est-il mont?

#

############################################
# Synchroniser les fichiers supprims
############################################

#le fichier ConfFolder/master/biblio/contexte.log est-il accessible?

#





##################################################################
#                           SOUS PROGRAMMES                      #
##################################################################

# find : cherche les rplication de dossiers sur un systme externe


sub find
{
  my $cwd = shift;
  my (@f, $f, $ff);

  opendir(DIR, '.')
    || (($g || print STDERR "biblio: cannot opendir $cwd: $!\n"), return);
  @f = readdir DIR;
  closedir DIR;

  foreach $f (@f) {
    next if ($f eq '.' || $f eq '..');
    $ff = "$cwd/$f/";
    lstat $f;
    if (-d _) {
      $n=0; foreach (@guess) {if ($_ eq $f) {$matches[$n]=$ff};$n++};
      chdir($f)  || (($g || print STDERR "biblio: cannot chdir to $ff: $!\n"), next);
      find($ff);
      chdir('..') || die "biblio: cannot chdir back to .. from $ff: $!\n";
    }
  }

} # find

# DirCopyRecent : copie tous les fichiers plus rcent du rpertoire
sub DirCopyRecent
{
my $fromdir = shift;
my $todir = shift;

opendir(DIR, $fromdir); @f = readdir DIR; closedir DIR;

foreach $f (@f) {
   next if ($f eq '.' || $f eq '..');
   lstat $f;
   if (-d "$fromdir$f") {
                #chdir($f);
		# si $todir\/$f n'existe pas : le crer ?
               # DirCopyRecent("$fromdir\/$f","$todir\/$f");
                #chdir('..');
                next;
              };
   print("$fromdir$f , $todir$f\n");
   CopyRecent("$fromdir$f","$todir$f"); }
}

# CopyRecent : copie un fichier s'il est plus rcent
sub CopyRecent
{
my $from = shift;
my $to = shift;

my($gocopy,$datefrom,$dateto,$atime);
$gocopy=0;
($atime,$datefrom)= (stat($from))[8,9];
#printf "file %s updated at %s\n", $from,scalar localtime($atime);
# le fichier destination existet-il?
 #if (!e $to) {$gocopy=1} else
  if (! stat $to) {$gocopy=1} else
{# comparer les dates

$dateto=(stat($to))[9];

if ($datefrom > $dateto) {$gocopy=1};
#print("$datefrom -> $dateto -> $gocopy\n");
#printf "file %s updated at %s\n", $from,scalar localtime($datefrom);
};

# faire la copie

if ($gocopy==1)
   { printf "file %s is updated at %s\n", $from,scalar localtime($datefrom);
     copy($from,$to);
     utime($atime,$datefrom,$to); #ne fonctionne que pour root sur un systme FAT32
     $copied[$ncops]=$to;
     $ncops++ ;
  };
};


# Suppression de fichiers

# il faut supprims les fichiers qui ont ts supprims sur master (get) sur client (push)

# si $sens=get lister les fichiers supprims sur master
if ($sens eq 'get')
{ # appeler synchlog.pl get
 exec('synchlog.pl get');
};

# si sens=push lister les fichiers supprims sur client

