#!/usr/bin/perl -w

use File::Copy;
 
#######################################################
# function b_synchronise
# b_synchronise direction(string) contexte(string)
#    faire une liste des rpertoires  synchroniser
#       direction='get' (<-master), ='push' (->master)
#       ouvrir les tiroirs un  un  
#       prendre les chemins des chemises   
#    vrifier le contenu de la disquette? (optionnel)
#    vrifier le contenu du CDROM? (optionnel)
#    chercher la base "master" dans contexte.bib
#       ouvrir une connection; lister et mettre  jour
#######################################################

#################################
# les connections rseau :
#   - connection monte
#   - client FTP
################################
$contexte=$ARGV[1];
$sens=$ARGV[0];
# dterminer ou est le master?
open(f,'<biblio.ini') ||die "bibio.ini not found" ;
while (<f>) {chop;chop; if ($_ eq "[master]") {last}; };
$mode=<f>;$master=<f>;
close(f);
print("la racine du montage est : $master\nsens : $sens\n");
#$master='192.168.2.1';

#rcuprer la liste des rpertoires (du contexte) dans %chemins;
# Faire la liste des guess (les "top" rpertoires) dans %guess;
open (f,'<'.$contexte.'.bib') ||die "$contexte.bib not found" ;
while (<f>) {chop;chop; if ($_ eq "[Tiroirs]") {last}; };
$n=0;
while (<f>) 
{ chop;chop;
     if ($_ eq "[fin]") {last};
     $tiroir=$_;
     $fic="<$contexte-$tiroir.box";
     open(ff,$fic);
     $afile=<ff>;
     while (<ff>){chop;chomp; $chemins[$n]=$_;$matches[$n]='0'; $guess[$n]=substr($_,1+rindex($_,"/")); print("$chemins[$n] et guess : $guess[$n]\n"); $n++; $afile=<ff>;};
     close(ff);
 };
close(f);

#quelle machine master et quel protocole?
# protocoles :
# montage sur /mnt/biblio
# ftp://master/
#
 

#############################################################
# chercher une maj sur un montage local du master (mountpoint)
#############################################################

#ici on regarde dans /mnt/biblio
if (-e "$master\/biblio")
 {  print("$master est mont\n");

#chercher rcursivement les guess dans /mnt/biblio
#mettre dans %matches les chemins distants
require Cwd;
$start_dir = Cwd::cwd();
chdir($master);
find($master);  
chdir($start_dir);  
# dans chaque %chemins copier le contenu de %matches 
# copier chaque fichier qui est plus rcent
# respecter la date du fichier
foreach (@matches) {print("match $_\n");};
$n=0; foreach (@chemins) 
{
if ($matches[$n] ne '0')
  {if ($sens eq 'get'){DirCopyRecent($matches[$n],$chemins[$n])}
      else{DirCopyRecent($chemins[$n],$matches[$n])};
   $n++}
};
 } 

###########################################
# chercher une maj sur le ftp du master
###########################################
  
#ici on fait du client ftp 
 else 
  {print("$master n'est pas mont\n");
  };





#################################
# chercher une maj sur le CDROM
#################################

#le CDROM est-il mont?

#







##################################################################
#                           SOUS PROGRAMMES                      #
##################################################################

# find : cherche les rplication de dossiers sur un systme externe


sub find
{
  my $cwd = shift;
  my (@f, $f, $ff);

  opendir(DIR, '.')
    || (($g || print STDERR "biblio: can't opendir $cwd: $!\n"), return);
  @f = readdir DIR;
  closedir DIR;

  foreach $f (@f) {
    next if ($f eq '.' || $f eq '..');
    $ff = "$cwd/$f";
    lstat $f;
    if (-d _) {
      $n=0; foreach (@guess) {if ($_ eq $f) {$matches[$n]=$ff};$n++};
      chdir($f)
        || (($g || print STDERR "biblio: can't chdir to $ff: $!\n"), next);
      find($ff);
      chdir('..')
        || die "biblio: can't chdir back to .. from $ff: $!\n";
    }
  }

} # find

# DirCopyRecent : copie tous les fichiers plus rcent du rpertoire
sub DirCopyRecent
{
my $fromdir = shift;
my $todir = shift;

opendir(DIR, $fromdir); @f = readdir DIR; closedir DIR;

foreach $f (@f) {
   next if ($f eq '.' || $f eq '..');
   lstat $f;
   if (-d _) {
                #chdir($f);
		# si $todir\/$f n'existe pas : le crer ?
                DirCopyRecent("$fromdir\/$f","$todir\/$f");
                #chdir('..');
                next;
              };
   CopyRecent("$fromdir\/$f","$todir\/$f"); }
}

# CopyRecent : copie un fichier s'il est plus rcent
sub CopyRecent
{
my $from = shift;
my $to = shift;

my($gocopy,$datefrom,$dateto,$atime);
$gocopy=0;
($atime,$datefrom)= (stat($from))[8,9];
printf "file %s updated at %s\n", $from,scalar localtime($atime);
# le fichier destination existet-il?
 #if (!e $to) {$gocopy=1} else
  if (! stat $to) {$gocopy=1} else
{# comparer les dates


$dateto=(stat($to))[9];

if ($datefrom > $dateto) {$gocopy=1};
#print("$datefrom -> $dateto -> $gocopy\n");
#printf "file %s updated at %s\n", $from,scalar localtime($datefrom);
}
# faire la copie
if ($gocopy==1) {copy($from,$to); utime($atime,$datefrom,$to);};
}

